1
1
Разклонения 0
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

73 lines
1.2 KiB

преди 6 години
#!/usr/bin/env bash
преди 6 години
declare -r esc=$'\033'
declare -r c_reset="${esc}[0m"
declare -r c_red="${esc}[31m"
преди 6 години
declare -r fifo='/tmp/sshget.fifo'
declare -A domains=()
declare -A paths=()
declare -a files=()
преди 6 години
err() {
преди 6 години
printf "${c_red}%s${c_reset}\n" "$*" >&2
преди 6 години
}
die() {
exit 1
}
преди 6 години
usage() {
LESS=-FEXR less <<'HELP'
sshget <user@host1:/path/to/search ...>
HELP
}
преди 6 години
has() {
преди 6 години
local verbose=0
преди 5 години
if [[ $1 = '-v' ]]; then
преди 6 години
verbose=1
преди 6 години
shift
fi
преди 6 години
for c; do c="${c%% *}"
преди 6 години
if ! command -v "$c" &> /dev/null; then
преди 6 години
(( verbose > 0 )) && err "$c not found"
преди 6 години
return 1
fi
done
}
has -v fzf rsync || die
преди 6 години
cleanup() {
[[ -e "$fifo" ]] && rm "$fifo"
}
trap cleanup SIGHUP SIGINT SIGTERM
mkfifo "$fifo"
преди 6 години
if (( $# < 1 )); then
usage
die
fi
преди 6 години
for a; do
преди 6 години
host="${a%:*}"
преди 6 години
path="${a##*:}"
domains+=( ["$a"]="$host" )
paths+=( ["$a"]="$path" )
shift
done
for s in "${!domains[@]}"; do
преди 6 години
ssh "${domains[$s]}" "find ${paths[$s]}" | sed -r "s|^|${domains[$s]}:|" >> "$fifo" &
преди 6 години
done
преди 4 години
mapfile -t files < <(fzf -e --inline-info +s --multi --cycle --bind='Ctrl-A:toggle-all,`:jump' < "$fifo")
преди 6 години
if (( ${#files[@]} )); then
преди 5 години
rsync --protect-args -auvzP -e ssh "${files[@]}" .
преди 6 години
fi
cleanup